{"revision":"c10276e953456835cdbb1f3a60d58ae1980be353","document":{"id":40862,"path":"platform-security/connections-and-credentials/authentication-algorithms.md","title":"Authentication Algorithms","bundle":null,"doc_type":null,"release":"australia","body":"\n# Authentication Algorithms\n\nVerify the identity of the sender using Authentication Algorithms\n\nAllow integration steps to authenticate with web services that require complex or non-standard connection or credential mechanisms. Associate authentication algorithms to credential and connection aliases to reduce or eliminate the need to manually configure integration steps.\n\nYou can use an authentication algorithm to generate custom authentication data for your integration steps. Integration steps can use this dynamic data to create any custom artifacts necessary to authenticate with the target web service. For example, a REST step could create an authentication header, query parameters, or a token.\n\nAuthentication algorithms support the following steps:\n\n-   Get Connection Info Step\n-   REST Step\n-   SOAP Step\n\nFor more information, see [Integration steps](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/integrate-applications/integration-steps.md)\n\n## Authentication algorithm types\n\n-   **Amazon Signature Version 4**: This is a pre-built authentication algorithm to connect to Amazon Web Services.\n-   **Custom Authentication**: This is a template that developers can use to create their own authentication algorithms.\n\nTo know more, on how to configure the authentication algorithm, see [Configure an authentication algorithm](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/platform-security/connections-and-credentials/configure-authentication-algorithm.md).\n\n## Scripts\n\nInstance Authentication Scripts are on instance scripts part of **sys\\_script\\_include** table.\n\n| | |\n|---|---|\n|RequestAuthInternal|Read only script on instance, which supports generating AWS V4 signature or custom authentication that is sent with outbound request.|\n|RequestAuthAWSV4Signer|Script extending RequestAuthInternal to implement signer to generate AWS V4 signature.|\n|RequestAuthTwitterSigner|Script extending RequestAuthInternal to implement signer to generate Twitter signature using OAuth 1.0a.|\n|RequestAuthSampleCustomSigner|Sample script extending RequestAuthInternal to understand how to write custom signer on instance.|\n\nMID Authentication Scripts are on MID scripts part of **ecc\\_agent\\_script\\_include** table.\n\n| | |\n|---|---|\n|RequestAuthInternal|Read only script on MID, which supports generating AWS V4 signature or custom authentication that is sent with outbound request.|\n|RequestAuthAWSV4MIDSigner|Script extending RequestAuthInternal to implement signer to generate AWS V4 signature.|\n|RequestAuthTwitterSigner|Script extending RequestAuthInternal to implement signer to generate Twitter signature using OAuth 1.0a.|\n|RequestAuthSampleMidCustomSigner|Sample script extending RequestAuthInternal to understand how to write custom signer on MID.|\n\n## JavaScript API's\n\nFollowing are the JavaScript API's for authentication algorithm.\n\n-   [AuthCredential](https://developer.servicenow.com/dev.do#!/reference/api/utah/server/sn_auth-namespace/AuthCredentialAPI)\n-   [HttpRequestAuthedData](https://developer.servicenow.com/dev.do#!/reference/api/utah/server/sn_auth-namespace/HttpRequestAuthedDataAPI)\n-   [HttpRequestData](https://developer.servicenow.com/dev.do#!/reference/api/utah/server/sn_auth-namespace/HttpRequestDataAPI)\n-   [RequestAuthAPI](https://developer.servicenow.com/dev.do#!/reference/api/utah/server/sn_auth-namespace/RequestAuthAPI)\n\n"}}